\documentclass[11pt]{article}
\title{The MetaGrammar}
\author{Our Selves}
\begin{document}
\maketitle
\section{Motivations}
Write a manageable grammar for French language with good coverage properties
\section{?}
\section{Appendix: smg grammar' BNF}
Non-terminals are noted with an upper-case letter followed by lower cases.
\subsection{Terminals}
\paragraph{Comments}
In this grammar, the terminal \verb'DOCUMENTATION' stands for a {\em documenting comment}, i.e. that should be kept in
the process of translation to XML. This is introduced by a double percent character \verb|'%%'|;
the comment extends to the end of line;
example:
\begin{verbatim}
%% This is a very important comment.
\end{verbatim}

When two such comment lines follow each other they are collapsed into one documenting comment.
Such documenting comments will be attached, either to the next class, or to the most recently introduced property
inside a class. The grammar specifies the places where these comments are allowed to appear: before or after classes,
or between properties. Note that these comments are allowed to be absent, but they cannot appear in other places than
those specified below.

On the other hand, we also accept {\em simple comments}, which are simply ignored in the process of translation to XML;
these are introduced either by simple \verb|'%'|,
or by C-style comments, i.e. between  \verb|'\*'| and  \verb|'*\'|.
\paragraph{Identifiers}
Terminal \verb|IDENT| stands for a letter (upper or lower case) followed by non blanks: letters (possibly with
accents), digits, minus signs, underscores.\\
A \verb|MACRONAME| looks like an \verb|IDENT|, except it has an \verb|'@'| in front, e.g. \verb|'@pcas_set'|.
\paragraph{Other terminals}
We note here other terminals between simple quotes, e.g. \verb|';'| for a semi-colon.
\subsection{The grammar for smg}
\begin{verbatim}
Axiom: Dcllist Doc ;

Dcllist:  Dcl ;

Dcl:      Doc 'class' IDENT Doc '{' Doc Proplist '}'
        | Doc 'template' MACRONAME '=' Value
        | Doc 'path' MACRONAME '=' Path
        | Doc 'disable' IDENT ;

Proplist: /* the list of properties inside a class: maybe empty */
        | Property Doc
        | Property ';' Doc Proplist;

Property: Heritage | Pere     | Ancetre  | Precedence
        | Equality | Desc     | Equation | Node
        | Needs    | Provides | Guard    | Atomic ;

Heritage: '<:' IDENT ;

Pere:     Idname '>>' Idname ;

Ancetre:  Idname '>>+' Idname ;

Precedence: Idname '<' Idname ;

Equality: Idname '=' Idname ;

Desc:     'desc' '(' '[' Features ']' ')' ;

Features: /* possibly empty */
        | F
        | Features COMMA F ;

F: IDENT ':' Value ;

Guard:    Idname '=>' EqAlt
        | '~' Idname '=>' EqAlt ; /* '~' means negation */

EqAlt:    EqSeq
        | EqAlt '|' EqSeq ;

EqSeq:    EqElem
        | EqSeq1 ',' EqElem ;

EqSeq1:   EqElem
        | EqSeq1 ',' EqElem ;

EqElem:   EqTerm '=' EqTerm ;

Atomic:   '!' EqTerm ;

Equation: EqTerm '=' EqTerm ;

EqTerm:   RootOfPath Path
       | 'value' '(' Value ')' ;

Varname: '$' Idname ; /* The '$' allows to write variable names
                         reminiscent to Perl */

AtomAlts: Atom
        | Atom '|' AtomAlts ;

Atom:     IDENT | '+' | '-' ;

NValue:   Atom
        | Atom '|' AtomAlts ;

Value:    NValue
        | '~' NValue /* Remind: ~ is negation */
        | Varname
        | Varname '^' Value
        | MACRONAME
        | '[' Features ']' ;

Node:     VNode
        | 'opt' VNode ;

VNode:    RawNode
        | 'node' RawNode ;

RawNode:  Idname ':' Value ;

Path:     /* Possibly empty */
        | '.' IDENT Path 
        | '.' MACRONAME Path ;

RootOfPath : 'desc'
        | 'father' '(' Idname ')'
        | 'node' '(' Idname ')'
        | Varname ;

Needs:    '-' Idname ;

Provides: '+' Idname ;

Idname:   IDENT
        | Idname '::' IDENT ;

Doc: 
        | DOCUMENTATION Doc ;
\end{verbatim}
\subsection{Example: excerpts from french grammar}
\begin{verbatim}
%% disable verb_categorization_passive
disable verb_extraction
%% Macro for Finite Sets
template @kind_set = -|subj|obj|prepobj|
                       scomp|vcomp|prepvcomp|acomp|ncomp|prepscomp
%% Macro for Structures
template @arg_fs = [pcas:@pcas_set,kind:@kind_set,real:@real_set]
template @ht_fs = [cat:$cat,
                   arg0:$arg0^@arg_fs,
                   arg1:$arg1^@arg_fs,
                   arg2:$arg2^@arg_fs]

path @htcat = .ht.cat
path @arg0 = .ht.arg0

%% All anchoring syntactic categories
class categories {
    node Anchor : [type:anchor];
    desc.@htcat = node(Anchor).cat;
    node(Anchor).id = node(Anchor).cat;
    desc([ht:@ht_fs]);
}

class adj 
{
    <: categories;
    node adj : [cat: adj]; adj=Anchor;
    desc.ht = value([arg0: [pcas: -,kind: subj],
                     arg1: @emptyarg_fs,
                     arg2: @emptyarg_fs]);
    Root >> adj;
    - adj::agreement; adj = adj::N;
}
\end{verbatim}
\end{document}
